<?php

// =========================================================
//
// This Software is copyright (c) 2007 by telepark, 
// Inh. Patrick Thomas, www.telepark.de. 
// All rights reserved. 
// You may not modify, alter, reverse engineer or emulate 
// the functionality, or create derivative works of the 
// Software in parts or it's entirety without the prior
// written consent of telepark.
// =========================================================


class Database {
	
	var $dbfolder;
 	var $table;
	var $db_error;
 	var $splitstring;
	var $header;
	var $result;
 	var $pos;
	var $primary;
	var $primaryval;
	var $dbprefix;
	var $maxqueye;
	var $usesession;
 	var $maxbackups;
 	var $dontbackup;
	var $backuptime;
	 	
	/**
	 * Constructor (PHP5)
	 */
	function __construct() {
		$this->dbfolder = DB_FOLDER;
		$this->dbprefix = WIKI_PREFIX."wdb";
		$this->splitstring="\n";
		$this->db_error="";
		$this->result=array();
		$this->header=array();
		$this->maxqueye=30;
		$this->backuptime=12; //hours
		$this->maxbackups=5;
		$this->dontbackup=array("sessions");
		$this->backup();
	}
	
	/**
	 * Constructor (PHP4)
	 */
	function Database() {
		if ((int) phpversion()<5) $this->__construct();
	}

	/**
	 * Database functions
	 */
	 
	/**
	 * Query usage: (this is for getting table data)
	 * query(string tablename, string fieldlist, string where, string order by)
	 * fieldlist=string of comma separated fields to include in query (empty=all)
	 * where=string of comma separated pairs of: field(!)=(~)value (no quotes) - all conditions have to be met (like "AND")
	 * order=string containing: field/(ASC,DESC,ASCN,DESCN) (ASCN&DESCN for numeric sorting) /comma separate if sorting on more then one field, max=5/ /if want to substract field value from some value use format: value-field/ASCN,DESCN; if sorting is done by absolute value of substracted result use format ABSvalue-field/ASCN,DESCN /
	 */	 
	function query($tablename,$fieldlist="",$where="",$orderby="") {
		//$this->_wait_queye($tablename);
		$this->db_error="";
		unset($this->pos);
		if ($this->load($tablename)) {
			$tmpres=$_SESSION[$this->dbprefix.'_table_'.$this->table];
			if ($where=="") {
				$tmpresult=$tmpres;
			} else {
				$count=count($tmpres);
				$wheres=explode(",",$where);
				foreach ($wheres as $w) {
					$w1=explode("=",$w);
					$not=false;
					$in=false;
					if (substr($w1[0],-1,1)=="!") {
						$w1[0]=substr($w1[0],0,strlen($w1[0])-1);
						$not=true;
					}
					if (substr($w1[1],0,1)=="~") {
						$w1[1]=substr($w1[1],1);
						$in=true;
					}
					$field=trim($w1[0]);
					$value=trim($this->unescapecomma($w1[1]));
					for ($i=0; $i<$count; $i++) {
						$change=false;
						if (isset($tmpres[$i][$field])) {
							if (!$not) {
								if ($in) {
									$change=(strpos($tmpres[$i][$field],$value)===false);
								} else {
									$change=($tmpres[$i][$field]!=$value);
								}
							} else {
								if ($in) {
									$change=(strpos($tmpres[$i][$field],$value)!==false);
								} else {
									$change=($tmpres[$i][$field]==$value);
								}
							}
						}
						if ($change) unset($tmpres[$i]);
					}
				}
				$tmpresult=$tmpres;
			}
			if (($orderby!="") AND (is_array($tmpresult))) {
				$allOrders=explode(",",$orderby);
				for ($i=0; $i<count($allOrders); $i++) {
					$orderby=$allOrders[$i];
					$o1=explode("/",$orderby);
					$field=trim($o1[0]);
					unset($tmp);
					$valueadd=0;
					$tmp=explode("-",$field);
					if (isset($tmp[1])) {
						$field=$tmp[1];
						$abs=false;
						$valueadd=$tmp[0];
						if (strpos($valueadd,"ABS")!==false) {
							$valueadd=str_replace("ABS","",$valueadd);
							$abs=true;
						}
						$valueadd=intval($valueadd);
					}
					$ordertmp=trim($o1[1]);
					$flag[$i]=SORT_STRING;
					if (substr($ordertmp,-1,1)=="N") {
						$ordertmp=substr($ordertmp,0,strlen($ordertmp)-1);
						$flag[$i]=SORT_NUMERIC;
					}
					if ($ordertmp=="ASC") $order[$i]=SORT_ASC;
					if ($ordertmp=="DESC") $order[$i]=SORT_DESC;
	
					foreach ($tmpresult as $key => $row) {
	    				if ($valueadd==0) {
	    					$sort[$i][$key]  = $row[$field];
	    				} else {
	    					$sort[$i][$key]  = $valueadd-$row[$field];
	    					if ($abs) $sort[$i][$key]  = abs($sort[$i][$key]);
	    				}
					}
				}
				$_count=count($allOrders)-1;
				if (isset($sort)) {
					switch ($_count) {
						case 0:
							array_multisort($sort[0], $order[0], $flag[0], $tmpresult);
						break;				
						case 1:
							array_multisort($sort[0], $order[0], $flag[0], $sort[1], $order[1], $flag[1], $tmpresult);
						break;	
						case 2:
							array_multisort($sort[0], $order[0], $flag[0], $sort[1], $order[1], $flag[1], $sort[2], $order[2], $flag[2], $tmpresult);
						break;	
						case 3:
							array_multisort($sort[0], $order[0], $flag[0], $sort[1], $order[1], $flag[1], $sort[2], $order[2], $flag[2], $sort[3], $order[3], $flag[3], $tmpresult);
						break;	
						case 4:
							array_multisort($sort[0], $order[0], $flag[0], $sort[1], $order[1], $flag[1], $sort[2], $order[2], $flag[2], $sort[3], $order[3], $flag[3], $sort[4], $order[4], $flag[4], $tmpresult);
						break;	
						default:
							array_multisort($sort[0], $order[0], $flag[0], $sort[1], $order[1], $flag[1], $sort[2], $order[2], $flag[2], $sort[3], $order[3], $flag[3], $sort[4], $order[4], $flag[4], $sort[5], $order[5], $flag[5], $tmpresult);
						break;	
					}
				}
			}
			unset($this->result);
			$this->result=array();
			if ($fieldlist!="") {
				$fields=explode(",",$fieldlist);
				for ($i=0; $i<count($tmpresult); $i++) {
					foreach ($this->header as $th) {
						if (!in_array($th,$fields) AND isset($tmpresult[$i][$th])) unset($tmpresult[$i][$th]);
					}
				}
			}
			if (is_array($tmpresult)) {
				$this->result=array_merge($tmpresult);
			} else {
				if ($tmpresult) $this->result[0]=$tmpresult;
			}
			$this->pos=0;
			$this->_clear_queye();
			return true;
		} else {
			$this->_clear_queye();
			return false;
		}
	}

	/**
	 * Show number of rows from previous query
	 * Returns:
	 * int number of rows
	 */	 
	function num_rows() {
		if (isset($this->pos)) {
			return count($this->result);
		} else {
			$this->db_error="No previous query";
			return 0;
		}
	}

	/**
	 * Fetch one row from previous query
	 * Returns:
	 * associative array with field values of one row
	 */	 
	function fetch_row() {
		$this->db_error="";
		if (isset($this->pos)) {
			$ret=false;
			if (isset($this->result[$this->pos])) {
				$this->db_error="";
				$ret=$this->result[$this->pos];
				$this->pos++;
			}
			if ($ret===false) {
				unset($this->pos);
				$this->result="";
			} else {
				$tmp=$ret;
				$ret=array();
				foreach ($tmp as $key=>$val) {
					$ret[$key]=str_replace(array("&lf;","&cr;"),array("\n","\r"),$val);
				}
			}
			return $ret;
		} else {
			$this->db_error="No previous query";
			return false;
		}
	}
	
	/**
	 * Update usage: (this is for updating existing table data)
	 * update(string tablename, string fieldlist, string where)
	 * fieldlist=string of comma separated fieldname=newvalue (no quotes)
	 * where=string of comma separated pairs of: field(!)=(~)value (no quotes)
	 */	 
	function update($tablename,$update,$where) {
		$this->_wait_queye($tablename);
		$this->db_error="";
		if ($this->load($tablename,true)) {
			$tmpres=$_SESSION[$this->dbprefix.'_table_'.$this->table];
			$update=explode(",",$update);
			$updates=array();
			foreach ($update as $u) {
				$u1=explode("=",$u);
				$c=count($updates);
				if (trim($u1[0])!=$this->primary) {
					$updates[$c]['field']=trim($u1[0]);
					$updates[$c]['value']=trim($this->unescapecomma($u1[1]));
				}
			}
			$count=count($tmpres);
			$changedres=$tmpres;
			$wheres=explode(",",$where);
			for ($i=0; $i<$count; $i++) {
				$change=true;
				foreach ($wheres as $w) {
					$w1=explode("=",$w);
					$not=false;
					$in=false;
					if (substr($w1[0],-1,1)=="!") {
						$w1[0]=substr($w1[0],0,strlen($w1[0])-1);
						$not=true;
					}
					if (substr($w1[1],0,1)=="~") {
						$w1[1]=substr($w1[1],1);
						$in=true;
					}
					$field=trim($w1[0]);
					$value=trim($this->unescapecomma($w1[1]));
					if ($not) {
						if ($in) {
							$change=$change&(strpos($tmpres[$i][$field],$value)===false);
						} else {
							$change=$change&($tmpres[$i][$field]!=$value);
						}
					} else {
						if ($in) {
							$change=$change&(strpos($tmpres[$i][$field],$value)!==false);
						} else {
							$change=$change&($tmpres[$i][$field]==$value);
						}
					}
				}
				if ($change) {
					for ($i2=0; $i2<count($updates); $i2++) {
						$changedres[$i][$updates[$i2]['field']]=$updates[$i2]['value'];
					}
				}
			}
			$tmp=$this->_save($changedres);
			$this->_clear_queye();
			return $tmp;
		} else {
			$this->db_error="Error in update: couldn't load $tablename";
			$this->_clear_queye();
			return false;
		}
	}
	
	/**
	 * Delete usage: 
	 * delete(string tablename, string where)
	 * where=string of comma separated pairs of: field(!)=(~)value (no quotes)
	 */	 
	function delete($tablename,$where) {
		$this->_wait_queye($tablename);
		$this->db_error="";
		if ($this->load($tablename,true)) {
			$tmpres=$_SESSION[$this->dbprefix.'_table_'.$this->table];
			$count=count($tmpres);
				$wheres=explode(",",$where);
				foreach ($wheres as $w) {
					$w1=explode("=",$w);
					$not=false;
					$in=false;
					if (substr($w1[0],-1,1)=="!") {
						$w1[0]=substr($w1[0],0,strlen($w1[0])-1);
						$not=true;
					}
					if (substr($w1[1],0,1)=="~") {
						$w1[1]=substr($w1[1],1);
						$in=true;
					}
					$field=trim($w1[0]);
					$value=trim($this->unescapecomma($w1[1]));
					for ($i=0; $i<$count; $i++) {
						$change=false;
						if ($not) {
							if ($in) {
								$change=(strpos($tmpres[$i][$field],$value)===false);
							} else {
								$change=($tmpres[$i][$field]!=$value);
							}
						} else {
							if ($in) {
								$change=(strpos($tmpres[$i][$field],$value)!==false);
							} else {
								$change=($tmpres[$i][$field]==$value);
							}
						}
						if ($change) unset($tmpres[$i]);
					}
				}
			$tmp=$this->_save(array_merge($tmpres));
			$this->_clear_queye();
			return $tmp;
		} else {
			$this->db_error="Error in update: couldn't load $tablename";
			$this->_clear_queye();
			return false;
		}
	}
	
	/**
	 * Add_row usage: (this is for updating existing table data)
	 * add_row(string tablename, string row)
	 * row=string of comma separated fieldname=value (no quotes)
	 * NOTE: first field in header is unique autoincrement!
	 */	 
	function add_row($tablename,$row) {
		$this->_wait_queye($tablename);
		$this->db_error="";
		$tmperror="";
		if ($this->load($tablename,true)) {
			$tmpres=$_SESSION[$this->dbprefix.'_table_'.$this->table];
			$count=count($tmpres);
			if ($tablename=="users") {
				$key=explode("|",base64_decode(KEYCODE));
				if ($key[1]!=-1) {
					if (!($count<$key[1])) {
						$this->db_error="LIMIT";
						return true;
					}
				}
			}
			$row=explode(",",$row);
			foreach ($row as $r) {
				$fieldset=true;
				$r1=explode("=",$r);
				$field=trim($r1[0]);
				if ($field==$this->primary) {
					$tmperror="Warning in add_row: fieldname $field is primary autoincrement and can not be set. It's value is skipped.";
					$fieldset=false;
				}
				$value=trim($this->unescapecomma($r1[1]));
				if (!in_array($field,$this->header)) {
					$this->db_error="Error in add_row: fieldname $field doesn't exist in table $tablename";
					break;
				} else {
					if ($fieldset) $tmpres[$count][$field]=trim($value);
				}
			}
			if ($this->db_error=="") {
				if ($this->primaryval==2000000000) $this->primaryval=0;
				$this->primaryval++;
				$tmpres[$count][$this->primary]=$this->primaryval;
				foreach ($this->header as $th) {
					if (!isset($tmpres[$count][$th])) $tmpres[$count][$th]="";
				}
				if ($tmperror!="") $this->db_error=$tmperror;
				$tmp=$this->_save($tmpres);
				$this->_clear_queye();
				return $tmp;
			} else {
				$this->_clear_queye();
				return false;
			}
		} else {
			$this->db_error="Error in add_row: couldn't load $tablename";
			$this->_clear_queye();
			return false;
		}	
	}
	
	/**
	 * Create empty database if doesn't exist
	 * Usage:
	 * create(string tablename, string fieldlist/comma separated/)
	 * NOTE: first field in fieldlist is unique autoincrement!
	 */	 
	function create($tablename,$fieldlist) {
		$this->db_error="";
		$this->table=$tablename;
		$this->_wait_queye();
		$fieldlist=explode(",",$fieldlist);
		for ($i=0; $i<count($fieldlist); $i++) {
			$fieldlist[$i]=trim($fieldlist[$i]);
		}
		$this->_set_header(implode(":",$fieldlist));
		$this->_fwrite("",true);
		$tmp=$this->load($tablename,true);
		$this->_clear_queye();
		return $tmp;
	}

	/**
	 * Drop database
	 * Usage:
	 * drop(string tablename)
	 */	 
	function drop($tablename) {
		$this->db_error="";
		$this->table=$tablename;
		$this->_wait_queye();
		$filename=$this->_table_filename();
		if (file_exists($filename)) {
			@unlink($filename);
		}
		$this->_clear_queye();
	}

	function backup() {
		@clearstatcache();
		$last=@filemtime($this->dbfolder."lastbackup.txt");
		if (!$last) $last=0;
		$count=0;
		if (file_exists($this->dbfolder."lastbackup.txt")) {
			$count=trim(implode("",@file($this->dbfolder."lastbackup.txt")));
			$count++;
		}
		if ($count==$this->maxbackups) $count=0;
		$now=time();
		if ($now<=($last+$this->backuptime*60*60)) return;
		if ($handle = @opendir($this->dbfolder)) {
	   	 	while (false !== ($file = readdir($handle))) {
		   	    if (strpos($file,".db.php") && !in_array(str_replace(".db.php","",$file),$this->dontbackup)) {
		            @copy($this->dbfolder.$file,$this->dbfolder.str_replace(".db.php",".db.back".$count.".php",$file));
		        }
		    }
		    closedir($handle);
		}
		$count=strval($count);
		$fp = @fopen($this->dbfolder."lastbackup.txt", "wb");
		if ($fp) {
			flock($fp,2);
			fputs($fp,$count,strlen($count));
			flock($fp,3);
			fclose($fp);
		}
	}

	function load($tablename,$reload=false) {
		$this->table=$tablename;
		if ($this->_tableChanged($tablename)) $reload=true;
		if (!$this->_is_open() OR $reload) {
				if ($reload) unset($_SESSION[$this->dbprefix.'_table_'.$this->table]);
				$_SESSION[$this->dbprefix.'_table_'.$this->table]=array();
				$content=$this->_fread();
				if ($content!==false) {
					if ($content!="") {
						$content=explode($this->splitstring,$content);
						$count=0;
						$row=0;
						while ($count<count($content)) {
							foreach ($this->header as $h) {
								$_SESSION[$this->dbprefix.'_table_'.$this->table][$row][$h]=$content[$count];
								$count++;
							}
							$row++;
						}
						$this->primaryval=intval($_SESSION[$this->dbprefix.'_table_'.$this->table][$row-1][$this->header[0]]);
					} else {
						$this->primaryval=-1;
					}
					$this->primary=$this->header[0];
					if (!$this->_is_open()) $_SESSION[$this->dbprefix.'_open_tables'][]=$this->table;
					$_SESSION[$this->dbprefix.'_md5_'.$this->table]=md5_file($this->_table_filename());
					return true;
				} else {
					return false;
				}
		} else {
			$this->_get_header();
			$this->primary=$this->header[0];
			if (isset($_SESSION[$this->dbprefix.'_table_'.$this->table]) AND isset($_SESSION[$this->dbprefix.'_table_'.$this->table][count($_SESSION[$this->dbprefix.'_table_'.$this->table])-1][$this->header[0]])) {
				$this->primaryval=intval($_SESSION[$this->dbprefix.'_table_'.$this->table][count($_SESSION[$this->dbprefix.'_table_'.$this->table])-1][$this->header[0]]);
			} else {
				$this->primaryval=-1;
			}
			return true;
		}
	}

	/**
	 * Core functions
	 */
	 function _is_open() {
		if (isset($_SESSION[$this->dbprefix.'_open_tables'])) {
			if (is_array($_SESSION[$this->dbprefix.'_open_tables'])) {
				return in_array($this->table,$_SESSION[$this->dbprefix.'_open_tables']);
			} else {
				return false;
			}
		} else {
			return false;
		}
	 }
	 
	 function _tableChanged($tablename) {
	 	if (!isset($_SESSION[$this->dbprefix.'_md5_'.$tablename])) {
			$_SESSION[$this->dbprefix.'_md5_'.$this->table]=md5_file($this->_table_filename());
	 		return true;
	 	} else {
	 		if ($_SESSION[$this->dbprefix.'_md5_'.$this->table]==md5_file($this->_table_filename())) return false;
	 	}
 		return true;
	 }
	 
	 function _get_header() {
	 	if (isset($_SESSION[$this->dbprefix.'_headers_'.$this->table])) {
			$this->header=explode(":",$_SESSION[$this->dbprefix.'_headers_'.$this->table]);
			return true;
		} else {
			$this->db_error="No header for table: ".$this->table;
			return false;
		}
	 }
	 
	 function _set_header($h) {
	 	$this->header=explode(":",$h);
		$_SESSION[$this->dbprefix.'_headers_'.$this->table]=$h;
	 }
	 
	function _table_filename() {
		return $this->dbfolder . $this->table.".db.php";
	}
	
	function _fread() {
		$fp = @fopen($this->_table_filename(), "rb");
		if ($fp) {
			$content="";
			flock($fp,1);
		    while (!feof($fp)) {
				$content.=fgets($fp);
		    }
 			flock($fp,3);
			fclose($fp);
			$content=base64_decode($content);
			$content=explode("***db_header_end***",$content);
			$this->_set_header($content[0]);
			return $content[1];
		} else {
			$this->db_error="Couldn't open table file for reading: ".$this->_table_filename();
			return false;
		}
	}
	
	function _save($content) {
		$tmp="";
		foreach ($content as $c) {
			if ($tmp!="") $tmp.=$this->splitstring;
			$tmp2="";
			foreach ($this->header as $th) {
				if ($tmp2!="") $tmp2.=$this->splitstring;
				$tmp2.=$c[$th];
			}
			$tmp.=$tmp2;
		}
		if ($this->_fwrite($tmp)) {
			$this->load($this->table,true);
			return true;
		} else {
			return false;
		}
	}

	function _fwrite($content,$checkexists=false) {
		if ($checkexists AND file_exists($this->_table_filename())) {
			$this->db_error="Table already exists: ".$this->table;
			return false;
		}
		$fp = @fopen($this->_table_filename(), "wb");
		if ($fp) {
			if ($this->_get_header()) {
				$content=implode(":",$this->header)."***db_header_end***".$content;
				$content=base64_encode($content);
				flock($fp,2);
				fputs($fp,$content,strlen($content));
				flock($fp,3);
				fclose($fp);
				return true;
			} else {
				return false;
			}
		} else {
			$this->db_error="Couldn't open table file for writing: ".$this->_table_filename();
			return false;
		}
	}
	
	function escapecomma($string) {
		return str_replace(array(",","=","\n","\r"),array("&comma;","&equal;","&lf;","&cr;"),$string);
	}

	function unescapecomma($string) {
		return str_replace(array("&comma;","&equal;"),array(",","="),$string);
	}
	
	function makeQuery($data) {
		if (!is_array($data)) return "";
		$ret=array();
		foreach ($data as $key=>$value) {
			$ret[]=$key."=".$this->escapecomma($value);
		}
		return implode(",",$ret);
	}
	
	function _lockfile() {
		return str_replace(".db.php",".db.lock.php",$this->_table_filename());
	}

	function _set_queye() {
		//return;
		$lockfile=$this->_lockfile();
		$fp=@fopen($lockfile,"w");
		@fwrite($fp,"1");
		@fclose($fp);
	}	
	
	function _clear_queye() {
		//return;
		$lockfile=$this->_lockfile();
		if (file_exists($lockfile)) @unlink($lockfile);
	}
	
	function _wait_queye($tablename="") {
		if ($tablename!="") $this->table=$tablename;
		//set_time_limit($this->maxqueye*2);
		if ($this->_is_queye_set()) $this->_wait_queye();
		$this->_set_queye();
	}
	
	function _is_queye_set() {
		//return false;
		$lockfile=$this->_lockfile();
		@clearstatcache();
		if (file_exists($lockfile)) {
			$ftime=@filemtime($lockfile);
			if ($ftime===false) $ftime=0;
			if ($ftime<(time()-$this->maxqueye)) {
				$this->_clear_queye();
				return false;
			} else {
				return true;
			}
		} else {
			return false;
		}
	}
	
	function sum($tablename) {
		$this->_wait_queye($tablename);
		$ret=md5_file($this->_table_filename());
		$this->_clear_queye();
		return $ret;
	}

}
?>