<?php

// =========================================================
//

// This Software is copyright (c) 2007 by telepark, 
// Inh. Patrick Thomas, www.telepark.de. 
// All rights reserved. 

// You may not modify, alter, reverse engineer or emulate 
// the functionality, or create derivative works of the 
// Software in parts or it's entirety without the prior
// written consent of telepark.
// =========================================================

ini_set("magic_quotes_gpc","Off");
ini_set("magic_quotes_runtime","Off");

if (!function_exists("getUrl")) {
	
	if (!defined("PRE")) {
		if (file_exists("includes/config.inc.php")) define("PRE","");
		 else define("PRE","../");
	}
	
	include_once(PRE . "includes/product.inc.php");

	if (file_exists(PRE."includes/session.inc.php")) require_once(PRE."includes/session.inc.php");

	include_once(PRE . "includes/config.inc.php");
	
	error_reporting(E_ALL ^ E_NOTICE);
	//error_reporting(0);
	
	if (file_exists("setup.php")) {
		if (isset($_POST['setup_step'])) {
			header("Location: setup.php?finish=".$_POST['setup_step']);
		} else {
			header("Location: setup.php");
		}
	}
	// init error message
	$errormsg = "";
	
	if (!function_exists("file_put_contents")) {
		function file_put_contents($filename,$text) {
			$fp = @fopen($filename, "w");
			if ($fp) {
				flock($fp,2);
				fputs($fp,$text);
				flock($fp,3);
				fclose($fp);
			}
			return filesize($filename);
		}
	} 
	
	if (!function_exists("file_get_contents")) {
		function file_get_contents($filename) {
			$ret=file($filename);
			if ($ret!==false) $ret=implode("",$ret);
			return $ret;
		}
	} 
	
	function getUrl() {
		$url="?page=";
		$root=str_replace("/app_header.inc.php","",__FILE__);
		$root=str_replace("includes","",$root);
		$htaccess="";
		if (file_exists($root.".htaccess")) $htaccess=file_get_contents($root.".htaccess");
		$redirect=strpos($htaccess,"index.php?page=$1");
		if ($redirect!==false) $url="";
		return $url;
	}
	
	function explode_js($string) {
		$cdata=preg_match_all("/<\\!\\[CDATA\\[(.*)\\]\\]>/msU",$string,$cdata_inner,PREG_SET_ORDER);
		if ($cdata) {
			foreach ($cdata_inner as $c) {
				$string=str_replace($c[0],";\n".$c[1].";\n",$string);
			}
		}
		$startquotes=array("'",'"',"(");
		$endquotes=array("'",'"',")");
		$explodeby=";";
		$ret=array();
		$quote=false;
		$s=array();
		for ($i=0; $i<strlen($string); $i++) {
			$s[]=substr($string,$i,1);
		}
		$count=0;
		$inquotes=false;
		$quotedInBrackets=false;
		foreach ($s as $char) {
			if (!$quote) {
				$tmpQuote=array_search($char,$startquotes);
				if ($tmpQuote!==false) {
					$quote=$tmpQuote;
					$inquotes=true;
				}
			} else {
				if ($quote==2) {
					if (!$quotedInBrackets) {
						$tmpQuote=array_search($char,$startquotes);
						if ($tmpQuote!==false) {
							if ($tmpQuote!=2) $quotedInBrackets=$tmpQuote;
						}
					} else {
						if ($char==$endquotes[$quotedInBrackets]) $quotedInBrackets=false;
					}
				}
					if (!$quotedInBrackets AND $char==$endquotes[$quote]) {
						$quote=false;
						$inquotes=false;
					}
			}
			if (!$inquotes AND $char==$explodeby) {
				$count++;
			} else {
				if (!isset($ret[$count])) $ret[$count]="";
				$ret[$count].=$char;
			}	
		}
		$tmp=array();	
		foreach ($ret as $r) {
			if (trim($r)!="") $tmp[]=trim($r);
		}
		$ret=array();
		$i=0;
		while ($i<count($tmp)) {
			$j=count($ret);
			$line=$tmp[$i];
			$ret[$j]=$line;
			if ($i<(count($tmp)-1) AND substr($line,0,2)=="if" AND substr($line,-1,1)!="{" AND substr($tmp[$i+1],0,1)!="{") {
				$i++;
				$ret[$j].="; ".$tmp[$i];
				$i++;
				if (isset($tmp[$i])) {
					while (isset($tmp[$i]) AND substr(ltrim($tmp[$i]),0,strlen("else"))=="else") {
						$ret[$j].="; ".$tmp[$i];
						$i++;
					}
				}
			} else {
				$i++;
			}
		}
		return $ret;
	}
	
	define("GET_URL",getUrl());
	
	// check login
	function checkLogin() {
		define("LOGGEDIN","false");
		define("SUPERADMIN","false");
	}
	
	// get version number
	function getVersionNumber($changelog) {
		$version = '';
		if (file_exists($changelog)) {
			// Read file
			$file = file($changelog);
			// Search for first version entry
			foreach ($file as $row) {
	
				$string = explode(" ",$row);
	
				if ($string[0][0] == 'v') {
					$version = $string[0];
					break;
				}
			}
		}
		return $version;
	}
	
	// error handler
	function my_error_handler($type, $message, $file, $line) {
		global $errormsg;
		
		$fileC=array();
		if (file_exists($file)) $fileC=file($file);
		
		// build error message
		$error_types = array(9999=>"Application Error",1=>"Error",2=>"Warning",8=>"Notice",256=>"User Error",512=>"User Warning",1024=>"User Notice",2048=>"PHP5 Compatibility");
		
		$errordesc = "[" . date("Y-m-d H:i:s") . "]\n" ;
		$errordesc .= "\tError-Type: " . (key_exists($type,$error_types)?$error_types[$type]:$type) . "\n";
		$errordesc .= "\tMessage: " . stripslashes($message) . "\n";
		$errordesc .= "\tFile: " . $file . "\n";
		$errordesc .= "\tLine: " . $line . "(". (isset($fileC[$line-1])?$fileC[$line-1]:"") .")" . "\n";
		$errordesc .= "\tOrigin: " . __FILE__ . "\n\n";
		
		$errorlogfile = PRE . "UserFiles/Logs/error.log";
		$mode = "a";
		
		// switch error types
		switch ($type) {
			case 2048: break;
			default:
				// check if file is to be archived
				if (file_exists($errorlogfile)) {
					clearstatcache();
					$lastchange = filemtime($errorlogfile);
					// archive file
					if (date("Y-m-d",$lastchange) != date("Y-m-d",time())) {
						$n = 0;
						while (false === @rename($errorlogfile, PRE."UserFiles/Logs/error_".$n.".log")) {
							$n++;
						}
						$mode = "w";
					}
				}
				
				@$fp = fopen($errorlogfile,$mode);
				if (false===$fp) {
					$errormsg = err_LOGNOTWRITABLE;
				}
				else {
					fputs($fp,$errordesc);
				}
				@fclose($fp);
		}
	}

	set_error_handler("my_error_handler");
	
	include_once(PRE . "includes/lang/" . LANGUAGE . ".inc.php");
	include_once(PRE . "classes/class.wikipro.inc.php");			
	include_once(PRE . "classes/class.wiki.inc.php");
	include_once(PRE . "classes/class.database.inc.php");
	if (file_exists(PRE . "mobile/class.wikimobile.inc.php")) @include_once(PRE . "mobile/class.wikimobile.inc.php");
	if (!defined("IS_MOBILE")) define("IS_MOBILE",false);
	if (!defined("SPECIAL_PAGES")) define("SPECIAL_PAGES","");
	
	if (!isset($_SESSION[WIKI_PREFIX."sessionStarted"])) $_SESSION[WIKI_PREFIX."sessionStarted"]=time();
	checkLogin();
}
?>