<?php

// =========================================================
//

// This Software is copyright (c) 2007 by telepark, 
// Inh. Patrick Thomas, www.telepark.de. 
// All rights reserved. 

// You may not modify, alter, reverse engineer or emulate 
// the functionality, or create derivative works of the 
// Software in parts or it's entirety without the prior
// written consent of telepark.
// =========================================================

header('content-type: text/html; charset=utf-8');

include_once("install/includes/product.inc.php");

error_reporting(E_ALL);

$step = 0;
if (isset($_POST['setup_step'])) {
	$step = intval($_POST['setup_step']);
} else {
	if (isset($_GET['finish'])) $step=intval($_GET['finish']);
}

$createfolders=array();
$createfolders[]="css";
$createfolders[]="UserFiles";
$createfolders[]="includes";
$createfolders[]="imgs";
$createfolders[]="db";
$createfolders[]="modules";

$installfiles=array();
$installdirs=array();
$installdirs[]="includes";
$installdirs[]="includes/lang";
$installdirs[]="css";

if (!function_exists("file_put_contents")) {
	function file_put_contents($filename,$text) {
		$fp = @fopen($filename, "w");
		if ($fp) {
			flock($fp,2);
			fputs($fp,$text);
			flock($fp,3);
			fclose($fp);
		}
		return filesize($filename);
	}
} 

if (!function_exists("file_get_contents")) {
	function file_get_contents($filename) {
		$ret=file($filename);
		if ($ret!==false) $ret=implode("",$ret);
		return $ret;
	}
} 

if (!function_exists("apache_get_modules")) {
	function apache_get_modules() {
		ob_start();
		phpinfo();
		$info=ob_get_clean();
		$cgi=preg_match("/<td[^><]*>\\s*Server API[^><]*<\\/td>\\s*<td[^><]*>([^><]*)<\\/td>/",$info,$api);
		if ($cgi) {
			if (strpos(strtolower($api[1]),"cgi")===false) {
				$find=preg_match("/<td[^><]*>\\s*Loaded Modules[^><]*<\\/td>\\s*<td[^><]*>([^><]*)<\\/td>/",$info,$modules);
				if ($find) {
					$split=",";
					$modules=$modules[1];
					if (strpos($modules,",")===false) {
						$split=" ";
					} else {
						$modules=str_replace(" ","",$modules);
					}
					$modules=explode($split,$modules);
					return $modules;
				} else {
					return "skip";
				}
			} else {
				return "cgi";
			}
		} else {			
			return "skip";
		}
	}
}

foreach ($installdirs as $id) {
	if ($handle = @opendir("install/".$id."/")) {
   	 	while (false !== ($file = readdir($handle))) {
	   	    if ($file != "." && $file != "..") {
	            if (substr($file,-4,1)==".") {
					$installfiles[]=$id."/".$file;
				}
	        }
	    }
	    closedir($handle);
	}

}

if ($step==2) installFiles();

//update functions
function getAllClasses($filename) {
	$ret=array();
	$lines=file($filename);
	if ($lines===false) return false;
	foreach ($lines as $line) {
		if (strpos($line,"{")!==false) {
			$ret[]=trim(substr($line,0,strpos($line,"{")));		
		}		
	}
	return $ret;
}

function getAllConstants() {
	$ret=array();
	$filename="install/default_config.inc.php";
	$lines=file($filename);
	if ($lines===false) return false;
	foreach ($lines as $line) {
		if (strpos($line,"NO CHANGES FROM HERE ON")!==false) break;
		if (strpos($line,'define(')!==false) {
			$start=strpos($line,'define(');
			$start=strpos($line,'"',$start)+1;
			$end=strpos($line,'"',$start);
			$ret[]=substr($line,$start,$end-$start);		
		}		
	}
	return $ret;
}

function getClass($filename,$class) {
	$ret=false;
	$file=file_get_contents($filename);
	$ok=false;
	$startpos=-1;
	while (!($ok)) {
		$startpos=strpos($file,$class." ",$startpos+1);
		if ($startpos===false) $startpos=strpos($file,$class."{");
		if ($startpos===false) break;
		$startpos1=strpos($file,"{",$startpos);
		if ($startpos1===false) break;
		$check=substr($file,$startpos,$startpos1-$startpos);
		if (str_replace(" ","",$check)==str_replace(" ","",$class)) $ok=true;
	}
		if ($ok) {
			$startpos=$startpos1+1;
			$endpos=strpos($file,"}",$startpos);
				if ($endpos!==false) {
					$ret=array();
					$classDef=substr($file,$startpos,$endpos-$startpos);
					$tmp=explode(";",$classDef);
					$commented=false;
					$com_num=1;
					foreach ($tmp as $t) {
						if (strpos(trim($t),"/*")===0) $commented=true;
						if (!$commented) {
							$tmp2=explode(":",$t);
							if (trim($tmp2[0])!="" && isset($tmp2[1])) $ret[trim($tmp2[0])]=trim($tmp2[1]);
						} else {
							if (strpos(trim($t),"*/")!==false) {
								$commented=false;
								$tmp2=explode(":",str_replace("*/","",$t));
								if (trim($tmp2[0])!="" && isset($tmp2[1])) $ret[trim($tmp2[0])]=trim($tmp2[1]);
								$ret['commented'.($com_num-1)].=" */";
							} else {
								$ret['commented'.$com_num]=trim($t).";";
								$com_num++;
							}
						}
					}
				}
		}
	return $ret;
}

function putClass($filename,$class,$classDef) {
	$tmpClass=$class." {\n";
	foreach (array_keys($classDef) as $cD) {
		if (strpos($cD,"commented")===false) {
			if ($classDef[$cD]!="undefined") $tmpClass.="\t$cD: ".$classDef[$cD].";\n";
		} else {
			$tmpClass.="\t".$classDef[$cD]."\n";
		}
	}
	$tmpClass.="}";
	$ret=false;
	$file=file_get_contents($filename);
	$ok=false;
	$startpos=-1;
	while (!($ok)) {
		$startpos=strpos($file,$class." ",$startpos+1);
		if ($startpos===false) $startpos=strpos($file,$class."{");
		if ($startpos===false) break;
		$startpos1=strpos($file,"{",$startpos);
		if ($startpos1===false) break;
		$check=substr($file,$startpos,$startpos1-$startpos);
		if (str_replace(" ","",$check)==str_replace(" ","",$class)) $ok=true;

	}
		if ($ok) {
			$endpos=strpos($file,"}",$startpos);
				if ($endpos!==false) {
					$firstPart=substr($file,0,$startpos);
					$secondPart=substr($file,$endpos+1);
					$file=$firstPart.$tmpClass.$secondPart;
					file_put_contents($filename,$file);
					$ret=true;
				}
		}
	if ($ret===false) {
		$file.=$tmpClass;
		file_put_contents($filename,"\n".$file."\n");
		$ret=true;
	}
	return $ret;
}

function getConstant($constant,$filename) {
	$ret="NOT FOUND";
	$file=file_get_contents($filename);
	$startpos=strpos($file,'define("'.$constant.'"');
	if ($startpos!==false) {
		$startpos=strpos($file,'"',$startpos+9+strlen($constant));
		if ($startpos!==false) {
			$startpos++;
			$escpos=strpos($file,"\'",$startpos);
			$endfrom=$startpos;
			while ($escpos!==false) {
				$escpos=$escpos+2;
				$endfrom=$escpos+1;
				$escpos=strpos($file,"\'",$escpos);
			}
			$endpos=strpos($file,'"',$endfrom);
			if ($endpos!==false) {
				$ret=substr($file,$startpos,$endpos-$startpos);
			}
		}
	}
	return $ret;
}

function updateConfig() {
	$filename="includes/config.inc.php";
	$file=file_get_contents($filename);
	$tmp=explode("// ======================= //",$file);
	$tmp[0]=ereg_replace('define\\(([^,]*),[^"]*\'([^\']*)\'[^"]*\\);','define(\\1,"\\2");',$tmp[0]);
	$tmp[0]=ereg_replace('define\\(([^,]*),\\s*([^"]*)\\s*\\);','define(\\1,"\\2");',$tmp[0]);
	$file=implode("// ======================= //",$tmp);
	if (strpos($file,"// permissions v20")===false) {
		$perms=file_get_contents("install/permissions.inc.php");
		$file=str_replace("?>",$perms."\n\n?>",$file);
	}
	if (strpos($file,'$_SESSION["WIKI_PREFIX"]=WIKI_PREFIX;')===false) {
		$perms='if (isset($_SESSION["WIKI_PREFIX"])) define("WIKI_PREFIX", $_SESSION["WIKI_PREFIX"]);'."\n\n".'if (!defined("WIKI_PREFIX")) define("WIKI_PREFIX", md5(ROOT_URL));'."\n\n".'$_SESSION["WIKI_PREFIX"]=WIKI_PREFIX;'."\n";
		$file=str_replace('if (!defined("WIKI_PREFIX")) define("WIKI_PREFIX", md5(ROOT_URL));',$perms,$file);
	}
	//bug fix
	$file=str_replace('define("ROOT_URL",(($_SERVER[\'SERVER_PORT\']==443)?"https://":"http://") . $_SERVER[\'HTTP_HOST\'] . $folder);','define("ROOT_URL",str_replace("/ajax","",(($_SERVER[\'SERVER_PORT\']==443)?"https://":"http://") . $_SERVER[\'HTTP_HOST\'] . $folder));',$file);
	$file=str_replace('if (isset($_SESSION["WIKI_PREFIX"])) define("WIKI_PREFIX", $_SESSION["WIKI_PREFIX"]);','',$file);
	$file=str_replace('$_SESSION["WIKI_PREFIX"]=WIKI_PREFIX;','',$file);
	$file=str_replace('if (!defined("WIKI_PREFIX")) define("WIKI_PREFIX", md5(ROOT_URL));','if (!defined("WIKI_PREFIX")) define("WIKI_PREFIX", md5(__FILE__));',$file);
	file_put_contents($filename,$file);
}

function putConstant($constant,$value) {
	$ret=false;
	if ($constant!="KEYCODE") {
		$value=str_replace('\"',"'",$value);
		$value=str_replace("\'","'",$value);
	}
	$filename="includes/config.inc.php";
	$file=file_get_contents($filename);
	$startpos=strpos($file,'define("'.$constant.'"');
	if ($startpos!==false) {
		$startpos=strpos($file,',',$startpos+9+strlen($constant))+1;
		if ($startpos!==false) {
			$endpos=strpos($file,'"',$startpos+1);
			if ($endpos!==false) {
				$firstPart=substr($file,0,$startpos+1);
				$secondPart=substr($file,$endpos);
				$file=$firstPart.$value.$secondPart;
				file_put_contents($filename,$file);
				$ret=$value;
			}
		}
	}
	return $ret;

}

function addConstant($constant,$value) {
	$filename="includes/config.inc.php";
	$file=file_get_contents($filename);
	$tmp=explode("// ======================= //",$file);
	$tmp[0].="\ndefine(\"$constant\",\"$value\");\n\n";
	$file=implode("// ======================= //",$tmp);
	file_put_contents($filename,$file);
}

function updateCSS($filename) {
	$removeOldClasses=array("#loginBox","#loginBox input","#innerLoginBox");
	if (file_exists("css/".$filename)) {
		if ($filename=="wiki.css") {
			$tmp=file_get_contents("css/".$filename);
			$tmp=str_replace("#textLinks","#textlinks",$tmp);
			file_put_contents("css/".$filename,$tmp);
		} 
		if (file_exists("install/default_".$filename)) {
			$all=getAllClasses("install/default_".$filename);
			foreach ($all as $a) {
				$default=getClass("install/default_".$filename,$a);
				$old=getClass("css/".$filename,$a);
				$def_keys=array_keys($default);
				if (($old===false) OR (in_array($a,$removeOldClasses))) { 
					$old=$default;
				} else {
					$old_keys=array_keys($old);
					foreach ($old_keys as $k) {
						if (!isset($default[$k])) unset($old[$k]); 
					}
					foreach ($def_keys as $k) {
						if (!isset($old[$k])) $old[$k]=$default[$k];
					}
				}
				putClass("css/".$filename,$a,$old);
			}
		}
	} else {
		copy("install/default_".$filename,"css/".$filename);
	}
}

function updatePages() {
	if ($handle = @opendir("UserFiles/Pages/")) {
   	 	while (false !== ($file = readdir($handle))) {
	   	    if ($file != "." && $file != "..") {
	            $content=file_get_contents("UserFiles/Pages/".$file);
	            $content=str_replace("?telepark.wiki=","?page=",$content);
	            file_put_contents("UserFiles/Pages/".$file,$content);
	        }
	    }
	    closedir($handle);
	}
}

// test write permissions
function test_write_permissions() {
	global $allok;	
	global $createfolders;
	global $installfiles;
	
	$allok = true;
	$skip_test = false;
	$checkUserFiles=false;

	$winServer=false;

	if (eregi("win",$_SERVER['SERVER_SOFTWARE']) OR eregi("microsoft",$_SERVER['SERVER_SOFTWARE'])) {
		$skip_test = false;
		$winServer=true;
	}

	if (file_exists("UserFiles")) {
		$checkUserFiles=true;
		$userfiles=array( 0 => "UserFiles/Changes", 1 => "UserFiles/File", 2 => "UserFiles/Logs", 3 => "UserFiles/Menu", 4 => "UserFiles/Newsletter", 5 => "UserFiles/Pages", 6 => "UserFiles/upload", 7 => "UserFiles/tmp", 8 => "UserFiles/upload/superadmin", 9 => "UserFiles/File/superadmin");
		
		foreach ($userfiles as $u) {
			if (!file_exists($u)) $checkUserFiles=@mkdir($u);
			@chmod($u,0777);
			if (!$checkUserFiles) break;
		}
	}
	
	if ($checkUserFiles) {
		// folders to be checked
		$folders = array("UserFiles/" => "0777", "UserFiles/Changes" => "0777", "UserFiles/File" => "0777", "UserFiles/Logs" => "0777", "UserFiles/Menu" => "0777", "UserFiles/Newsletter" => "0777", "UserFiles/Pages" => "0777", "UserFiles/upload" => "0777", "UserFiles/upload/superadmin" => "0777", "UserFiles/File/superadmin" => "0777", "UserFiles/tmp" => "0777", "css/" => "0777", "imgs/" => "0777", "FCKeditor/" => "0777", "sitemap.xml" => "0666");
	}	else {
		// folders to be checked
		$folders = array("UserFiles/" => "0777", "css/" => "0777", "imgs/" => "0777", "FCKeditor/" => "0777", "sitemap.xml" => "0666");	
	}

	$addfolders="";
	foreach ($createfolders as $cf) {
		if ($addfolders!="") $addfolders.=" and ";
		$addfolders.="'".$cf."'";
		if ($cf!="modules" OR $winServer) {
			$folders[$cf."/"]="0777";
		} else {
			$folders[$cf."/"]="0755";
		}
	}

	foreach ($installfiles as $ins) {
		if (file_exists(str_replace("default_","",$ins))) {
			$folders[$ins] = "0666";
			$tmp=explode("/",$ins);
		}
	}
	
	if (file_exists("includes/config.inc.php")) $folders['includes/config.inc.php']="0666";

	if ($handle = opendir("install/")) {
   	 	while (false !== ($file = readdir($handle))) {
	   	    if ($file != "." && $file != "..") {
	            if (strpos($file,"default_")!==false) {
	            	$tmp=str_replace("default_","",$file);
	            	if (file_exists("css/".$tmp)) $folders["css/".$tmp]="0666";
				}
	        }
	    }
	    closedir($handle);
	}

	$writable="";
	foreach ($folders as $name=>$val) {
		$writable.=$name."<br/><br/>";
	}
	$skip_en = "Windows Server detected! <br/>Check the permissions manually!<br/>Folders and files listed below must have write permissions: <br/><br/>".$writable;
	$skip_de = "Windows-Server erkannt! <br/>Prüfen Sie die Verzeichnisrechte von Hand!<br/>Die folgenden Verzeichnisse und Dateien müssen beschreibbar sein (ohne Schreibschutz): <br/><br/>".$writable;
	
	$no_rewrite_en="Apache mod_rewrite module isn't enabled in your server installation! <br/>If you are installing on www server please contact hoster to enable it.<br/>For instructions on how to check your local XAMPP installation click <a href=\"install/xampp_install_help_en.txt\" target=\"_blank\">here</a>.<br/><br/>Setup will exit now!";
	$no_rewrite_de="Das Apache-Modul mod_rewrite ist in Ihrer Server-Konfiguration nicht aktiviert! <br/>Falls Sie auf einem www-Server installieren, kontaktieren Sie bitte Ihren Hosting-Provider um mod_rewrite zu aktivieren.<br/>Eine kurze Anleitung zur Prüfung Ihrer lokalen XAMPP Server-Installation finden Sie <a href=\"install/xampp_install_help_de.txt\" target=\"_blank\">hier</a>.<br/><br/>Das Setup-Programm wird jetzt beendet!";
		
	$manually_en = "The script was not able to change the permissions automatically. Please perform the neccessary changes manually with your FTP client (chmod).";
	$manually_de = "Das Skript konnte die Verzeichnisrechte nicht automatisch anpassen. Bitte führen Sie die oben angegebenen Änderungen manuell mit einem FTP-Programm durch (chmod).";
	
	$cgi_detect_en="PHP is running as a CGI on your server!";
	$cgi_detect_de="PHP läuft als CGI auf Ihrem Server!";
	
	$manual_htaccess_en="Can not determine is mod_rewrite module enabled in your server installation! <br/>If you are installing on www server please contact hoster to enable it if not already.<br/>For instructions on how to check your local XAMPP installation click <a href=\"install/xampp_install_help_en.txt\" target=\"_blank\">here</a>.";
	$manual_htaccess_de="Das Installationsprogramm kann nicht erkennen, ob das Apache-Modul mod_rewrite auf Ihrem Server aktiviert ist!<br/>Falls Sie auf einem www-Server installieren, kontaktieren Sie bitte Ihren Hosting-Provider um mod_rewrite zu aktivieren.<br/>Eine kurze Anleitung zur Prüfung Ihrer lokalen XAMPP Server-Installation finden Sie <a href=\"install/xampp_install_help_de.txt\" target=\"_blank\">hier</a>.";
	
	$everythingok_en = "Setup finished!<br /><br />Have fun using ".PRODUCT."!";
	$everythingok_de = "Setup fertiggestellt!<br /><br />Viel Spaß mit ".PRODUCT."!";

	$extra_en="";
	$extra_de="";

	$apache=apache_get_modules();
	if (is_array($apache)) {
		if (!in_array("mod_rewrite", $apache)) {
			return array($no_rewrite_en,$no_rewrite_de,true);
		}
	} else {
		if ($apache=="cgi") {
			$extra_en="$cgi_detect_en<br/>$manual_htaccess_en<br/><br/>";
			$extra_de="$cgi_detect_de<br/>$manual_htaccess_de<br/><br/>";
		} else {
			$extra_en="$manual_htaccess_en<br/><br/>";
			$extra_de="$manual_htaccess_de<br/><br/>";
		}
	}

	
	$missingFolders=array();
	
	$gocheck=true;
	
	foreach ($createfolders as $cf) {
		$gocheck=true;
		if (!file_exists($cf."/")) $gocheck=@mkdir($cf."/");
		if (!($gocheck)) $missingFolders[]=$cf;	
	}

	if (count($missingFolders)==0) {

	// Windows Server -> Skip permissions test
	if ($skip_test == true) {
		return array($extra_en.$skip_en . "<br /><br />" . $everythingok_en, $extra_de.$skip_de . "<br /><br />" . $everythingok_de);
	
	// No Windows Server -> Test
	} else {
		// table
		echo "<table border=\"1\" cellpadding=\"5\" cellspacing=\"0\">";
		// table header
		echo "<tr><th>Folder / Ordner</th><th>Permission / Rechte</th><th>Change to / Zu ändern in</th></tr>\n";
		
		foreach ($folders as $folder => $permission) {
			echo "<tr>";
			
			// read permsissions
			clearstatcache();
			$perms = decoct(fileperms($folder));
			$perms = substr((string) $perms,strlen((string) $perms)-4);
			
			// try to change permissions if neccessary
			if ($perms != $permission) {
				if ($permission=="0777") @chmod($folder,0777);
				if ($permission=="0666") @chmod($folder,0666);
			}
			
			// read permissions again
			clearstatcache();
			$perms = decoct(fileperms($folder));
			$perms = substr((string) $perms,strlen((string) $perms)-4);
			
			if ($perms == $permission) {
				$color = "#00E000";
			}
			else {
				$color = "red";
				$allok = false;
			}
			echo "<td>" . $folder . ": </td>";
			echo "<td style=\"text-align:center; font-weight:bold; color: $color;\">" . $perms . "</td>";
			echo "<td style=\"text-align:center; font-weight:bold\">" . (($perms != $permission)?$permission:" - ") . "</td>";
			echo "</tr>";
		}
	}
	
	echo "</table>\n";
	
	if ($allok == true) {
		return array($extra_en.$everythingok_en,$extra_de.$everythingok_de);
	}
	else { 
		return array($extra_en.$manually_en,$extra_de.$manually_de);
	}
	
	} else {
		$addfolders="";
		foreach ($missingFolders as $cf) {
			if ($addfolders!="") $addfolders.=" and ";
			$addfolders.="'".$cf."'";
		}
		$nouserfiles_en='<div style="color: red; font-size: 14px; font-weight: bold;">Please create folders named '.$addfolders.' on your server!</div>';
		$nouserfiles_de='<div style="color: red; font-size: 14px; font-weight: bold;">Bitte erstellen Sie folgende Ordner auf Ihrem Server: '.$addfolders.'</div>';
	
		$allok=false;
		return array($extra_en.$nouserfiles_en,$extra_de.$nouserfiles_de);
	}
	
}

// get version number
function getVersionNumber($changelog) {
	$version = '';
	if (file_exists($changelog)) {
		// Read file
		$file = file($changelog);
		// Search for first version entry
		foreach ($file as $row) {

			$string = explode(" ",$row);

			if ($string[0][0] == 'v') {
				$version = $string[0];
				break;
			}
		}
	}
	return $version;
}


function installFiles() {
	global $step;
	global $installfiles;
	$step=3;
	
	$versionNo=getVersionNumber("changelog.txt");

	$upgradedTo="";
	
	if (file_exists("includes/upgrade_finished.txt")) $upgradedTo=file_get_contents("includes/upgrade_finished.txt");

	if ($versionNo!=$upgradedTo) {

	$userfiles=array( 0 => "UserFiles/Changes", 1 => "UserFiles/File", 2 => "UserFiles/Logs", 3 => "UserFiles/Menu", 4 => "UserFiles/Newsletter", 5 => "UserFiles/Pages", 6 => "UserFiles/upload", 7 => "UserFiles/tmp");
	foreach ($userfiles as $u) {
		if (!file_exists($u)) mkdir($u);
		@chmod($u,0777);	
	}
	foreach ($installfiles as $ins) {
		$dir_tmp=str_replace(basename($ins),"",$ins);
		if (!file_exists($dir_tmp)) mkdir($dir_tmp);
		copy("install/".$ins,$ins);
		@chmod($ins,0644);
	}

	$compatFix=false;

	if (file_exists("includes/config.inc.php")) {
		$compatFix=true;
		updateConfig();
		$all=getAllConstants();	
		foreach ($all as $a) {
			$old=getConstant($a,"includes/config.inc.php");
			if ($old=="NOT FOUND") {
				$default=getConstant($a,"install/default_config.inc.php");
				addConstant($a,$default);
			}
		}
	} else {
		if (!file_exists("FCKeditor/fckstyles.xml")) copy("install/default_fckstyles.xml","FCKeditor/fckstyles.xml");
		if (!file_exists("FCKeditor/fcktemplates.xml")) copy("install/default_fcktemplates.xml","FCKeditor/fcktemplates.xml");
		copy("install/default_config.inc.php","includes/config.inc.php");
		updateConfig();
	}
	@chmod("includes/config.inc.php",0644);

	
	if ($handle = opendir('install/')) {
   	 	while (false !== ($file = readdir($handle))) {
	   	    if ($file != "." && $file != "..") {
	            if (substr($file,-4,4)==".css") {
	            	$fname=str_replace("default_","",$file);
	            	updateCSS($fname);
	            } 
	        }
	    }
	    closedir($handle);
	}
	
	//update imgs
	if ($handle = opendir('install/imgs/')) {
   	 	while (false !== ($file = readdir($handle))) {
	   	    if ($file != "." && $file != "..") {
	            if (substr($file,-4,1)==".") {
	            	if (!file_exists('imgs/'.$file)) copy('install/imgs/'.$file,'imgs/'.$file);
	            } 
	        }
	    }
	    copy('install/imgs/close.gif','imgs/close.gif');
	    closedir($handle);
	}
	
	if (!file_exists('imgs/colorpicker/')) mkdir('imgs/colorpicker/');
	if ($handle = opendir('install/imgs/colorpicker/')) {
   	 	while (false !== ($file = readdir($handle))) {
	   	    if ($file != "." && $file != "..") {
	            if (substr($file,-4,1)==".") {
	            	if (!file_exists('imgs/colorpicker/'.$file)) copy('install/imgs/colorpicker/'.$file,'imgs/colorpicker/'.$file);
	            } 
	        }
	    }
	    closedir($handle);
	}
	
	if ($compatFix) {
	//fix some compatibility issues
		$logo=getConstant("LOGO","includes/config.inc.php");
		if ($logo=="true") {
			putConstant("LOGO","YES");
		} else {
			putConstant("LOGO","NO");
		}
		
		$textLinksCSS=getClass("css/wiki.css","#textlinks");
		$text_links=getConstant("DISPLAYTEXTLINKS","includes/config.inc.php");
		if ($text_links=="true") {
			$textLinksCSS['display']="block";
		} else {
			$textLinksCSS['display']="none";
		}
		putClass("css/wiki.css","#textlinks",$textLinksCSS);
		
		$versionCSS=getClass("css/wiki.css","#version");
		$version=getConstant("DISPLAYVERSION","includes/config.inc.php");
		if ($version=="true") {
			$versionCSS['display']="block";
		} else {
			$versionCSS['display']="none";
		}
		putClass("css/wiki.css","#version",$versionCSS);
		
		//update menu.xml
		if (file_exists("UserFiles/Menu/menu.xml")) {
			$menuXml=file_get_contents("UserFiles/Menu/menu.xml");
		
			$menuXml=str_replace('im0="leaf.gif" im1="leaf.gif" im2="leaf.gif"','im0="leaf_closed.gif" im1="leaf_open.gif" im2="leaf_closed.gif"',$menuXml);
		
			file_put_contents("UserFiles/Menu/menu.xml",$menuXml);
		}
		
	}

	//htaccess in UserFiles
	define("INDEX_URL",str_replace("setup.php","",$_SERVER['PHP_SELF']));
	$s ="RewriteEngine On\n";
	$s .="RewriteRule ^upload/(.*)/(.*)$ ".INDEX_URL."upload.php?group=$1&file=$2 [L]\n";
	$s .="RewriteRule ^File/(.*)/(.*)$ ".INDEX_URL."file.php?group=$1&file=$2 [L]\n";
	$s .="RewriteRule ^upload/(.*)$ ".INDEX_URL."upload.php?file=$1&group= [L]\n";
	$s .="RewriteRule ^File/(.*)$ ".INDEX_URL."file.php?file=$1&group= [L]\n";
	if (!file_exists("UserFiles/.htaccess")) {
		file_put_contents("UserFiles/.htaccess",$s);
	} else {
		$tmp=implode("",file("UserFiles/.htaccess"));
		if (strpos($tmp,'^upload/(.*)$')===false) file_put_contents("UserFiles/.htaccess",$s);
	}
	
	file_put_contents("includes/upgrade_finished.txt",$versionNo);
	
	}
}

function keycode() {
	global $step;
	$step=3;
	$keycode="";
	$oldkeycode=getConstant("KEYCODE","includes/config.inc.php");
	if (isset($_REQUEST['keycode'])) {
		$keycode=$_REQUEST['keycode'];
		if ($keycode!="") {
			if ( get_magic_quotes_gpc() ) $keycode=stripslashes($keycode);
			putConstant("KEYCODE",str_replace('"','\"',str_replace("\\","\\\\",trim($keycode))));
			$step=4;
		} else {
			if ($oldkeycode!="") $step=4;
		}
	}
	if (isset($_REQUEST['lang']) && ($_REQUEST['lang']=="english" || $_REQUEST['lang']=="deutsch")) {
		putConstant("LANGUAGE",$_REQUEST['lang']);
	}
}

// finish
function finish() {
	$str = "";
	$ren = @rename("setup.php","setup_bak.php");
	if ($ren === false) {
		$str = "The file \"setup.php\" could not be renamed automatically. Please rename this file with your FTP client or delete it from the server.<br /><br />If you want to use full SEO of ".PRODUCT." you should also rename '.htaccess.template' to '.htaccess' and  in it change '(here put path to root folder of wiki)' to apropriate wiki root folder.";
		$str .= "Die Datei \"setup.php\" konnte nicht automatisch umbenannt werden. Bitte benennen Sie die Datei manuell mit Ihrem FTP-Programm um oder löschen Sie sie.<br /><br />";
	} else {
		$htaccess=@file_get_contents(".htaccess.template");
		if ($htaccess) {
			$htaccess=str_replace('/(here put path to root folder of wiki)/',str_replace("setup.php","",$_SERVER['PHP_SELF']),$htaccess);
			@file_put_contents(".htaccess",$htaccess);
		}
		header("Location: index.php");
	}
	return $str;
}

if ($step==3) {
	keycode();
	updatePages();
}

if ($step==4) {
	$finish_text=finish();
}

echo "<html>\n";
echo "<head>\n";
echo "<title>".PRODUCT." - SETUP</title>\n";
echo "<style>body, table, tr, td { font-family:Verdana,Arial,Helvetica; font-size:13px; line-height:150%; } h1 { font-family:Verdana,Arial,Helvetica; font-size:18px; }</style>\n";
echo "</head>\n";

echo "<body>\n";

echo "<form action=\"";
if ($step==4) {
	echo "index.php";
} else {
	echo "setup.php";
}
echo "\" method=\"post\">\n";
echo "<table width=\"100%\" border=\"0\" cellpadding=\"15\">\n";
echo "<tr>\n";

// english
echo "<td align=\"center\">\n";
echo "<h1>Welcome to ".PRODUCT."</h1>\n";
echo "Your installation is almost finished!<br /><br />\n";
echo "</td>\n";
// german
echo "<td align=\"center\">\n";
echo "<h1>Willkommen zu ".PRODUCT."</h1>\n";
echo "Ihre Installation ist fast fertig!<br /><br />\n";
echo "</td>\n";
echo "</tr>\n";

if ($step==3) {
	$lang=getConstant("LANGUAGE","includes/config.inc.php");
	echo "<tr>\n";
	echo "<td colspan=\"2\" align=\"center\">";
	echo "Keycode:&nbsp;<input type=\"text\" name=\"keycode\" value=\"\" style=\"width: 400px\"/>&nbsp;&nbsp;Lang:&nbsp;<select name=\"lang\"><option value=\"english\"".(($lang=="english")?" selected=\"selected\"":"").">English</option><option value=\"deutsch\"".(($lang=="deutsch")?" selected=\"selected\"":"").">Deutsch</option></select><br /><br />";
	echo "<input type=\"submit\" value=\"Save | Speichern\"/>\n";
	echo "</td>\n";
	echo "</tr>\n";
	echo "</table>\n";
	echo "<input type=\"hidden\" name=\"setup_step\" value=\"".$step."\"/>\n";
	echo "</body></html>\n";
	exit;
}

if ($step==4) {
	echo "<tr>\n";
	echo "<td colspan=\"2\" align=\"center\">";
	echo $finish_text."<br /><br />";
	echo "<input type=\"submit\" value=\"Try again | Nochmal versuchen\"/>\n";
	echo "</td>\n";
	echo "</tr>\n";
	echo "</table>\n";
	echo "<input type=\"hidden\" name=\"setup_step\" value=\"".$step."\"/>\n";
	echo "</body></html>\n";
	exit;
}


// check permissions
if ($step<3) {
	echo "<tr>\n";
	echo "<td colspan=\"2\" align=\"center\">\n";
	$result = test_write_permissions();
	echo "</td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	// english
	echo "<td align=\"center\">\n";
	echo "<br />" . $result[0];
	echo "</td>\n";
	// german
	echo "<td align=\"center\">\n";
	echo "<br />" . $result[1];
	echo "</td>\n";
	echo "</tr>\n";
	if (!(isset($result[2]) AND $result[2]===true)) {
		// submit
		echo "<tr>\n";
		echo "<td align=\"center\" colspan=\"2\"><br />\n";
	
		if ($allok != true) {
			$step=0;
			echo "<input type=\"submit\" value=\"Try again | Nochmal versuchen\"/>\n";
		} else {
			$step=2;
			echo "<input type=\"submit\" value=\"Finish | Fertigstellen\" name=\"finish\" />\n";
		}
	
		echo "</td>\n";
		echo "</tr>\n";
	}
}

echo "</table>\n";
echo "<input type=\"hidden\" name=\"setup_step\" value=\"".$step."\"/>\n";
echo "</form>\n";

echo "</body>\n";
echo "</html>\n";

?>
